// buynow.js is dependent on buyNowModule.js
loadJS();
window.onload=function(){
	$.support.cors = true;
    // loadJS();
    localizePage();
    setSize();

    var xafc = urlParseModule.getURLParameter("afc");
    var xsession = urlParseModule.getURLParameter("session");
    var xsecsession = urlParseModule.getURLParameter("secure_session");
    var xplanid = urlParseModule.getURLParameter("plan_id");
    // Change api calling server address according to version.
    var xurl = urlParseModule.getURLParameter("trans_server_url");
    var xcoupon = urlParseModule.getURLParameter("coupon");
    var xlocale = urlParseModule.getURLParameter("locale");
    xlocale = xlocale.replace("-", "_");

    // getBuynowPage();
    $.ajax({
        url: xurl + '/API/v1/Member?locale='+xlocale,
        type: 'PUT',
        dataType: 'json',
        success: getBuynowPage,
        error: buyNowErrorCallback,
        headers: {
            "X-AFC" : xafc,
            "X-Session" : xsession,
            "X-Secure-Session" : xsecsession
        }

    });
    

    $('#show_coupon_js').click(function(){
        window.location.href = "http://sketchbookNotification/banner/event?type=clicked&id=promo-code";
        $(this).fadeOut(function(){
            $('#enter_coupon').fadeIn(function(){
                $("#buyframe").height($("#s_content_short").height() - $("#coupon_entry").height() - 8);
            });
        });
    });

    $('#couponform').submit(function() {
        window.location.href = "http://sketchbookNotification/banner/event?type=clicked&id=promo-code-apply";
        hideFrame();
        hideCoupon();
        showLoading();
        var coupon = $('input[name=code]').val();
        if(coupon){
            buyNowModule.applyCoupon(coupon, applyCouponSuccessCallback, applyCouponFailCallback);
        }else{
            applyCouponFailCallback();
        }
        return false;
    });
};

String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

var handleMessage = function(event) {
    var parser = document.createElement('a');
    parser.href = event.origin;
    if (parser.hostname.endsWith(".squidplatform.com") || parser.hostname.endsWith(".123dapp.com")) {
      if (Object == event.data.constructor) {
        if ("mixpanel.track" == event.data["eventType"]) {
          var eventName = event.data["eventName"];
          var eventProperties = {};
          var propertyName = event.data["propertyName"];
          if (propertyName) {
            var propertyValue = event.data["propertyValue"];
            if ("@monthOrYear" == propertyValue) {
              propertyValue = "month";
            }
            eventProperties[propertyName] = propertyValue;
          }
          if(eventName === "confirm billing address"){
            window.location.href = "http://sketchbookNotification/banner/event?type=clicked&id=confirm-billing-address";
          }
        }
      }
    }
  }
  
if (window.addEventListener) {
    window.addEventListener("message", handleMessage, false);
} else {
    window.attachEvent("message", handleMessage);
}

function getBuynowPage(){
    var xafc = urlParseModule.getURLParameter("afc");
    var xsession = urlParseModule.getURLParameter("session");
    var xsecsession = urlParseModule.getURLParameter("secure_session");
    var xplanid = urlParseModule.getURLParameter("plan_id");
    // Change api calling server address according to version.
    var xurl = urlParseModule.getURLParameter("trans_server_url");
    var xcoupon = urlParseModule.getURLParameter("coupon");
    // if coupon code is transferred, then apply coupon directly. the coupon input field will not be shown then.
    if(xcoupon){
        buyNowModule.buynowWithCoupon(xcoupon, xurl, xplanid, xafc, xsession, xsecsession, buyNowWithCouponSuccessCallback, buyNowWithCouponErrorCallback);
    }else{
        buyNowModule.buynow(xurl, xplanid, xafc, xsession, xsecsession, buyNowSuccessCallback, buyNowErrorCallback);
    }
}

function loadJS(){
    var locale = urlParseModule.getURLParameter("locale") ? urlParseModule.getURLParameter("locale") : 'en-us';
    // locale = locale.toLowerCase();
    locale = sb_util.getLocaleFolder(locale);
    sb_util.loadjscssfile("../lang/" + locale + "/lan_buynow.js", "js", localizePage);
};

function localizePage(){
    $("#apply_button").text(lan_buynow["apply_button"]);
    $("#code_success").text(lan_buynow["code_success"]);
    $("#code_fail").text(lan_buynow["code_fail"]);
    $("#buynow_1").text(lan_buynow["buynow_1"]);
};

function setSize(){
    var height = window.innerHeight = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    document.body.style.height = height + "px";
    $("#s_content_short").height(height);

};

function hideFrame(){
    if(!$('#buyframe').hasClass('mhide')){
        $("#buyframe").addClass('mhide');
    }
};

function hideCoupon(){
    if(!$('#coupon_entry').hasClass('mhide')){
        $("#coupon_entry").addClass('mhide');
    }
};

function showLoading(){
    if($('#div_loading').hasClass('mhide')){
        $('#div_loading').removeClass('mhide');
    }
};

function applyCouponSuccessCallback(data){
    if($('#code_success').hasClass('mhide')){
        $("#code_success").removeClass('mhide');
    }
    if(!$('#code_fail').hasClass('mhide')){
        $("#code_fail").addClass('mhide');
    }
    $('input[name=code]').val("");
    $("#buyframe").height($("#s_content_short").height() - $("#coupon_entry").height() - 8);
    $("#buyframe").attr('src', data.BUYNOW_URL + "&in_app=true&t=SKETCH_NATIVE");
    window.location.href = "http://sketchbookNotification/banner/event?type=others&id=promo-code-success";
    
};

function applyCouponFailCallback(data){
    if($('#code_fail').hasClass('mhide')){
        $("#code_fail").removeClass('mhide');
    }
    if(!$('#code_success').hasClass('mhide')){
        $("#code_success").addClass('mhide');
    }
    $('input[name=code]').val("");
    $("#buyframe").height($("#s_content_short").height() - $("#coupon_entry").height() - 8);
    showFrame();
    
};

function buyNowWithCouponSuccessCallback(data){
    var buynowurl = data.BUYNOW_URL + "&in_app=true&t=SKETCH_NATIVE";
    $('#s_content_short').append("<iframe id='buyframe' class='mhide' frameBorder='0' onload='showFrameWithCoupon();' src='" + buynowurl +"'></iframe>");
    $("#buyframe").height($("#s_content_short").height() - $("#coupon_entry").height() - 8);
};

function buyNowWithCouponErrorCallback(jqXHR, textStatus, errorThrown){
    buyNowErrorCallback(jqXHR, textStatus, errorThrown);
};

function buyNowSuccessCallback(data) {
    var buynowurl = data.BUYNOW_URL + "&in_app=true&t=SKETCH_NATIVE";
    $('#s_content_short').append("<iframe id='buyframe' class='mhide' frameBorder='0' onload='showFrame();' src='" + buynowurl +"'></iframe>");
    $("#buyframe").height($("#s_content_short").height() - $("#coupon_entry").height() - 8);
};

function buyNowErrorCallback(jqXHR, textStatus, errorThrown) {
    // console.dir(textStatus);
    // var locale = urlParseModule.getURLParameter("locale") ? urlParseModule.getURLParameter("locale") : 'en-us';
    var folder = "html";
    if (jqXHR.status === 0) {
        // console.log('Not connect.\n Verify Network.');
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_internet.html'></iframe>");
    } else if (jqXHR.status == 404) {
        // console.log('Requested page not found. [404]');
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_server.html'></iframe>");
    } else if (jqXHR.status == 500) {
        // console.log('Internal Server Error [500].');
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_server.html'></iframe>");
    } else if (textStatus === 'parsererror') {
        // console.log('Requested JSON parse failed.');
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_server.html'></iframe>");
    } else if (textStatus === 'timeout') {
        // console.log('Time out error.');
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_server.html'></iframe>");
    } else if (textStatus === 'abort') {
        // console.log('Ajax request aborted.');
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_server.html'></iframe>");
    } else {
        // console.log("error");
        $('#s_content_short').append("<iframe id='no_internet_frame' class='mhide' frameBorder='0' scrolling='no' onload='showNoInternetFrame();' src='../" + folder + "/fail_internet.html'></iframe>");
    }

};

function showFrameWithCoupon(){
    if(!$('#div_loading').hasClass('mhide')){
        $('#div_loading').addClass('mhide');
    }
    if(!$('#coupon_entry').hasClass('mhide')){
        $('#coupon_entry').addClass('mhide');
    }
    if($('#buyframe').hasClass('mhide')){
        $("#buyframe").removeClass('mhide');
    }
};

function showFrame(){
	// console.log("iframe onload");
    if(!$('#div_loading').hasClass('mhide')){
        $('#div_loading').addClass('mhide');
    }
    // $('#loadingImg').css('visibility','hidden');
    if($('#coupon_entry').hasClass('mhide')){
        $('#coupon_entry').removeClass('mhide');
    }
    if($('#buyframe').hasClass('mhide')){
        $("#buyframe").removeClass('mhide');
    }
};

function showNoInternetFrame(){
    if(!$('#div_loading').hasClass('mhide')){
        $('#div_loading').addClass('mhide');
    }
    if(!$('#coupon_entry').hasClass('mhide')){
        $('#coupon_entry').addClass('mhide');
    }
    if($('#no_internet_frame').hasClass('mhide')){
        $("#no_internet_frame").removeClass('mhide');
    }
};

function OnImageLoad(evt)
{
    $("#loadingImg").height($("#div_loading").height());
    $("#loadingImg").css('visibility', 'visible');
};

