var buyNowModule = (function(){
	var xafc = "";
    var xsession = "";
    var xsecsession = "";
    var xurl = "";
    var xplanid = "";
    var xcoupon = "";
    var buyNowSuccessCallback;
    var buyNowErrorCallback;

    var setXafc = function(str){ xafc = str; };
    var setXsession = function(str){ xsession = str; };
    var setXsecsession = function(str){ xsecsession = str; };
    var setXurl = function(str){ xurl = str; };
    var setXplanid = function(str){ xplanid = str; };
    var setXcoupon =function(str){ xcoupon = str;};
    var setBuyNowSuccessCallback = function(callback){ buyNowSuccessCallback = callback; };
    var setBuyNowErrorCallback = function(callback) { buyNowErrorCallback = callback; };

    // must be called after the buynow page is retrieved
    var myApplyCoupon = function(coupon, applyCouponSuccessCallback, applyCouponFailCallback){

    	$.ajax({
	        url: xurl + '/API/v1/cart/coupon?code=' + coupon,
	        type: 'PUT',
	        dataType: 'json',
	        success: applyCouponSuccessCallback,
	        error: applyCouponFailCallback,
	        headers: {
	            "X-AFC" : xafc,
	            "X-Session" : xsession,
	            "X-Secure-Session" : xsecsession
	        }

	    });
    };

    var startBuyWithCoupon = function(){
    	clearCart(clearCartWithCouponSuccessCallback,buyNowErrorCallback);
    }

    var startBuyProcess = function(){
	    clearCart(clearCartSuccessCallback, buyNowErrorCallback);
	};

    var clearCart = function (succallback, errcallback){
	    $.ajax({
	        url: xurl + '/API/v1/cart',
	        type: 'DELETE',
	        dataType: 'json',
	        success: succallback,
	        error: errcallback,
	        headers: {
	            "X-AFC" : xafc,
	            "X-Session" : xsession,
	            "X-Secure-Session" : xsecsession
	        },
	        timeout: 10000
	    });
	};

	var putItemIntoCart = function(succallback, errcallback){
	    $.ajax({
	        // TODO: Need to make product_id and product_type dynamic.
	        url: xurl + '/API/v1/cart/lineitem?product_id='+xplanid+'&product_type=SUBSCRIPTION',
	        type: 'PUT',
	        dataType: 'json',
	        success: succallback,
	        error: errcallback,
	        headers: {
	            "X-AFC" : xafc,
	            "X-Session" : xsession,
	            "X-Secure-Session" : xsecsession
	        },
	        timeout: 10000
	    });
	};

    // try to get the buynow page in this step
	var putItemSuccessCallback = function(){
	    // console.log("putItemSuccessCallback");
	    getBuyNowPage(buyNowSuccessCallback, buyNowErrorCallback);
	    
	};

	var putItemWithCouponSuccessCallback = function(){
		myApplyCoupon(xcoupon, putItemSuccessCallback, putItemSuccessCallback);
	}

	var getBuyNowPage = function(succallback, errcallback){
		$.ajax({
	        url: xurl + '/API/v1/cart/buynow',
	        type: 'GET',
	        dataType: 'json',
	        success: succallback,
	        error: errcallback,
	        headers: {
	            "X-AFC" : xafc,
	            "X-Session" : xsession,
	            "X-Secure-Session" : xsecsession
	        },
	        timeout: 10000
	    });
	}

	var clearCartSuccessCallback = function(){
	    // console.log("clearCartSuccessCallback");
	    putItemIntoCart(putItemSuccessCallback, buyNowErrorCallback);
	};

	var clearCartWithCouponSuccessCallback = function(){
		putItemIntoCart(putItemWithCouponSuccessCallback, buyNowErrorCallback);
	}

    return {
    	buynow: function(xurl, xplanid, xafc, xsession, xsecsession, buyNowSuccessCallback, buyNowErrorCallback){
    		setXurl(xurl);
    		setXplanid(xplanid);
    		setXafc(xafc);
    		setXsession(xsession);
    		setXsecsession(xsecsession);
    		setBuyNowSuccessCallback(buyNowSuccessCallback);
    		setBuyNowErrorCallback(buyNowErrorCallback);

    		startBuyProcess();
    	},

    	applyCoupon: function(coupon, applyCouponSuccessCallback, applyCouponFailCallback){
    		setXcoupon(coupon);
    		setBuyNowSuccessCallback(applyCouponSuccessCallback);
    		setBuyNowErrorCallback(applyCouponFailCallback);
    		myApplyCoupon(coupon, putItemSuccessCallback, applyCouponFailCallback);
    	},

    	buynowWithCoupon: function(xcoupon, xurl, xplanid, xafc, xsession, xsecsession, buyNowWithCouponSuccessCallback, buyNowWithCouponErrorCallback){
       		setXcoupon(xcoupon);
       		setXurl(xurl);
       		setXplanid(xplanid);
    		setXafc(xafc);
    		setXsession(xsession);
    		setXsecsession(xsecsession);
    		setBuyNowSuccessCallback(buyNowWithCouponSuccessCallback);
    		setBuyNowErrorCallback(buyNowWithCouponErrorCallback);

    		startBuyWithCoupon();
    	}

    }

})();

