var imageProcessModule = (function(){
	var myScaleImage = function(srcwidth, srcheight, targetwidth, targetheight)
	{
	    var result = { width: 0, height: 0, fScaleToTargetWidth: true };
	            
	    if ((srcwidth <= 0) || (srcheight <= 0) || (targetwidth <= 0) || (targetheight <= 0)) {
	        return result;
	    }
	            
	    var ratioSrc = srcheight/srcwidth;
	    var ratioTar = targetheight/targetwidth;
	            
	    if(srcwidth <= targetwidth)
	    {
	        if(srcheight<=targetheight)
	        {
	            result.width = srcwidth;
	            result.height = srcheight;
	        }
	        else
	        {
	            result.width = targetheight / ratioSrc;
	            result.height = targetheight;
	        }
	    }
	    else
	    {
	        if(srcheight<=targetheight)
	        {
	            result.width = targetwidth;
	            result.height = targetwidth * ratioSrc;
	        }
	        else
	        {
	            if(ratioSrc < ratioTar)
	            {
	                result.width = targetwidth;
	                result.height = targetwidth * ratioSrc
	            }
	            else if(ratioSrc > ratioTar)
	            {
	                result.height = targetheight;
	                result.width = targetheight / ratioSrc;
	            }
	            else
	            {
	                result.width = targetwidth;
	                result.height = targetheight;
	            }
	        }
	    }
	    
	    result.targetleft = Math.floor((targetwidth - result.width) / 2);
	    result.targettop = Math.floor((targetheight - result.height) / 2);
	    
	    return result;
	};

	return {
		scaleImage: function(srcwidth, srcheight, targetwidth, targetheight){
			return myScaleImage(srcwidth, srcheight, targetwidth, targetheight);
		}
	};

})();