var sb_util = (function () {
	return {
		loadjscssfile: function(filename, filetype, callback){
		    if (filetype=="js"){ //if filename is a external JavaScript file
		    	var fileref=document.createElement('script');
		    	fileref.setAttribute("type","text/javascript");
		    	fileref.setAttribute("src", filename);
		    	fileref.onload = callback;
		    }
		    else if (filetype=="css"){ //if filename is an external CSS file
				var fileref=document.createElement("link")
				fileref.setAttribute("rel", "stylesheet")
				fileref.setAttribute("type", "text/css")
				fileref.setAttribute("href", filename)
				fileref.onload = callback;
			}
			if (typeof fileref!="undefined")
				document.getElementsByTagName("head")[0].appendChild(fileref)
		},
		
		getWindowWidth: function () {
			var w = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth || window.top.innerWidth;
			return w;
		},
		 
		getWindowHeight: function () {
		    var h = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight || window.top.innerHeight;
		    return h;
		},

		isRetina: function(){
			return (window.devicePixelRatio > 1 || (window.matchMedia && window.matchMedia("(-webkit-min-device-pixel-ratio: 1.5),(-moz-min-device-pixel-ratio: 1.5),(min-device-pixel-ratio: 1.5)").matches));
		},

		getLocaleFolder: function(locale){
			locale = locale.toLowerCase();
			switch(locale){
				case 'de-de':
				    break;
				case 'en-us':
				    break;
				case 'es-es':
					break;
				case 'fr-fr':
					break;
				case 'it-it':
					break;
				case 'ja-jp':
					break;
				case 'ko-kr':
					break;
				case 'pt-br':
					break;
				case 'ru-ru':
					break;
				case 'zh-cn':
					break;
				case 'zh-tw':
					break;
				default:
					locale = 'en-us';
					break;
			}
			return locale;
		}
		 
	};
 
})();